<ToolboxBitmap(GetType(LineSymbiote), "LineSymbioteTool.bmp")> _
Public Class LineSymbiote
    Inherits System.ComponentModel.Component

#Region " Component Designer generated code "

    Public Sub New(ByVal Container As System.ComponentModel.IContainer)
        MyClass.New()

        'Required for Windows.Forms Class Composition Designer support
        Container.Add(Me)
    End Sub

    Public Sub New()
        MyBase.New()

        'This call is required by the Component Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Component overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Component Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Component Designer
    'It can be modified using the Component Designer.
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container
    End Sub

#End Region
    Public Event Redraw()
    Public Event LineSelected(ByVal x0 As Single, ByVal y0 As Single, ByVal x1 As Single, ByVal y1 As Single)

    ' The PictureBox on which we will draw.
    Private WithEvents m_Canvas As Control

    ' Drawing variables.
    Private m_Drawing As Boolean
    Private m_X0 As Integer
    Private m_Y0 As Integer
    Private m_X1 As Integer
    Private m_Y1 As Integer

    ' The control on which we will draw.
    Public Property Canvas() As Control
        Get
            Return m_Canvas
        End Get
        Set(ByVal Value As Control)
            m_Canvas = Value
        End Set
    End Property

    ' Start drawing.
    Private Sub m_Canvas_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles m_Canvas.MouseDown
        If e.Button <> MouseButtons.Left Then Exit Sub
        m_Drawing = True

        ' Save the point.
        m_X0 = e.X
        m_Y0 = e.Y
        m_X1 = e.X
        m_Y1 = e.Y

        ' Draw the line.
        m_Canvas.CreateGraphics.DrawLine(Pens.Black, m_X0, m_Y0, m_X1, m_Y1)
    End Sub

    ' Continue drawing.
    Private Sub m_Canvas_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles m_Canvas.MouseMove
        If Not m_Drawing Then Exit Sub

        ' Erase the previous line.
        RaiseEvent Redraw()

        ' Save the new point.
        m_X1 = e.X
        m_Y1 = e.Y

        ' Draw the line.
        m_Canvas.CreateGraphics.DrawLine(Pens.Black, m_X0, m_Y0, m_X1, m_Y1)
    End Sub

    ' Finish drawing.
    Private Sub m_Canvas_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles m_Canvas.MouseUp
        If Not m_Drawing Then Exit Sub
        m_Drawing = False

        ' Raise the LineSelected event. 
        ' The main program can refresh the canvas if desired.
        RaiseEvent LineSelected(m_X0, m_Y0, m_X1, m_Y1)
    End Sub
End Class
